﻿using System;
using System.Runtime.ConstrainedExecution;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using Microsoft.Win32.SafeHandles;

namespace XenAdmin.Native
{

	public class WinExtern
	{
		public const int TO_UNICODE_BUFFER_SIZE = 64;

		[DllImport("user32.dll")]
		public static extern bool BringWindowToTop(IntPtr window);

		[DllImport("user32.dll")]
		public static extern bool CloseWindow(IntPtr window);

		[DllImport("user32.dll")]
		public static extern IntPtr CreateIconIndirect(ref ICONINFO iconinfo);

		[DllImport("user32.dll")]
		public static extern bool DestroyIcon(IntPtr hIcon);

		[DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = false)]
		public static extern IntPtr SendMessage(IntPtr hWnd, uint Msg, uint wParam, [MarshalAs(UnmanagedType.LPWStr)] string lParam);

		[DllImport("user32.dll")]
		public static extern bool GetComboBoxInfo(IntPtr hwnd, ref COMBOBOXINFO pcbi);

		[DllImport("user32.dll")]
		public static extern bool SetForegroundWindow(IntPtr window);

		[DllImport("user32.dll")]
		public static extern bool OpenIcon(IntPtr window);

		[DllImport("user32.dll")]
		public static extern IntPtr FindWindowEx(IntPtr parent, IntPtr childAfter, string className, string windowName);

		[DllImport("user32.dll", EntryPoint = "FindWindow")]
		public static extern IntPtr FindWindowWin32(string className, string windowName);

		[DllImport("user32.dll")]
		public static extern int SendMessage(IntPtr window, int message, int wparam, int lparam);

		[DllImport("user32.dll")]
		public static extern int PostMessage(IntPtr window, int message, int wparam, int lparam);

		[DllImport("user32.dll")]
		public static extern IntPtr GetParent(IntPtr window);

		[DllImport("user32.dll")]
		public static extern IntPtr GetDesktopWindow();

		[DllImport("user32.dll")]
		public static extern IntPtr GetForegroundWindow();

		[DllImport("user32.dll")]
		public static extern IntPtr GetLastActivePopup(IntPtr window);

		[DllImport("user32.dll")]
		public static extern int GetWindowText(IntPtr window, [In][Out] StringBuilder text, int copyCount);

		[DllImport("user32.dll")]
		public static extern bool SetWindowText(IntPtr window, string text);

		[DllImport("user32.dll")]
		public static extern int GetWindowTextLength(IntPtr window);

		[DllImport("user32.dll")]
		public static extern int SetWindowLong(IntPtr window, int index, int value);

		[DllImport("user32.dll")]
		public static extern IntPtr GetWindowLong(IntPtr window, int index);

		[DllImport("user32.dll")]
		public static extern int GetClassName(IntPtr window, [In][Out] StringBuilder text, int copyCount);

		[DllImport("user32.dll")]
		public static extern bool EnumChildWindows(IntPtr window, EnumWindowsProc callback, int i);

		[DllImport("user32.dll")]
		public static extern bool EnumThreadWindows(int threadId, EnumWindowsProc callback, int i);

		[DllImport("user32.dll")]
		public static extern bool EnumWindows(EnumWindowsProc callback, int i);

		[DllImport("user32.dll")]
		public static extern int GetWindowThreadProcessId(IntPtr window, ref int processId);

		[DllImport("user32.dll")]
		public static extern int GetWindowThreadProcessId(IntPtr window, IntPtr ptr);

		[DllImport("user32.dll")]
		public static extern bool IsChild(IntPtr parent, IntPtr window);

		[DllImport("user32.dll")]
		public static extern bool IsIconic(IntPtr window);

		[DllImport("user32.dll")]
		public static extern bool IsZoomed(IntPtr window);

		[DllImport("user32.dll")]
		public static extern IntPtr GetWindowDC(IntPtr hwnd);

		[DllImport("user32.dll")]
		public static extern int ReleaseDC(IntPtr hwnd, IntPtr dc);

		[DllImport("user32.dll")]
		public static extern bool MoveWindow(IntPtr hwnd, int X, int Y, int width, int height, bool repaint);

		[DllImport("user32.dll", CharSet = CharSet.Auto, EntryPoint = "GetWindow", SetLastError = true)]
		public static extern IntPtr GetNextWindow(IntPtr hwnd, [MarshalAs(UnmanagedType.U4)] int wFlag);

		[DllImport("user32.dll")]
		public static extern IntPtr GetWindow(IntPtr hWnd, uint uCmd);

		[DllImport("User32.dll", CharSet = CharSet.Auto, SetLastError = true)]
		public static extern bool PeekMessage(out NativeMessage message, IntPtr handle, uint filterMin, uint filterMax, uint removeMsg);

		[DllImport("user32.dll")]
		public static extern IntPtr SendMessage(IntPtr hWnd, int msg, IntPtr wParam, ref POINT pt);

		[DllImport("user32.dll")]
		public static extern IntPtr SendMessage(IntPtr hWnd, int msg, IntPtr wParam, IntPtr lParam);

		[DllImport("user32.dll")]
		public static extern IntPtr GetDCEx(IntPtr hWnd, IntPtr hrgnClip, int flags);

        [DllImport("user32")]
		public static extern int GetGuiResources(IntPtr hProcess, int uiFlags);

        [DllImport("user32.dll")]
		public static extern int ToUnicode(uint wVirtKey, uint wScanCode, IntPtr lpKeyState,
                                           [Out, MarshalAs(UnmanagedType.LPWStr, SizeConst = TO_UNICODE_BUFFER_SIZE)] StringBuilder pwszBuff,
                                           int cchBuff, uint wFlags);

        [DllImport("user32.dll")]
		public static extern bool GetKeyboardState(IntPtr lpKeyState);

        [DllImport("user32.dll")]
        public static extern Int32 FlashWindowEx(ref FLASHWINFO pwfi);

        [DllImport("user32.dll")]
		public static extern IntPtr GetClipboardViewer();

        [DllImport("user32.dll", SetLastError = true)]
        public static extern IntPtr SetClipboardViewer(IntPtr hWnd);

        [DllImport("user32.dll", SetLastError = true)]
        public static extern bool ChangeClipboardChain(IntPtr hWnd, IntPtr hWndNext);

        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        public static extern IntPtr GetDlgItem(IntPtr hDlg, int nIDDlgItem);

        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        public static extern IntPtr CreateWindowEx(uint dwExStyle, string lpClassName, string lpWindowName, uint dwStyle, int x, int y, int nWidth, int nHeight, IntPtr hWndParent, IntPtr hMenu, IntPtr hInstance, IntPtr lpParam);

        [DllImport("user32.dll")]
        public static extern bool SetWindowPos(IntPtr hWnd, IntPtr hWndInsertAfter, int X, int Y, int cx, int cy, uint uFlags);

        [DllImport("user32.dll")]
        public static extern bool ScreenToClient(IntPtr hWnd, ref POINT lpPoint);

        [DllImport("user32.dll")]
        public static extern bool GetWindowRect(IntPtr hWnd, ref RECT lpRect);

        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        public static extern bool SetWindowText(int hWnd, string lpString);

        [DllImport("user32.dll")]
        public static extern bool DestroyWindow(IntPtr hwnd);

        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = false)]
        public static extern IntPtr SendMessage(IntPtr hWnd, int Msg, IntPtr wParam, string lParam);

        [DllImport("user32.dll")]
        public static extern IntPtr SetFocus(IntPtr hwnd);

        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool GetScrollInfo(IntPtr hWnd, int n, ref ScrollInfo lpScrollInfo);

        [DllImport("user32.dll")]
        public static extern int SetScrollInfo(IntPtr hwnd, int fnBar, [In] ref ScrollInfo lpsi, bool fRedraw);

        [DllImport("user32.dll", SetLastError = true)]
        public static extern IntPtr FindWindow(string lpClassName, string lpWindowName);

        [DllImport("user32.dll", SetLastError = true)]
		[return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool PostMessage(IntPtr hWnd, uint Msg, IntPtr wParam, IntPtr lParam);

        [DllImport("user32.dll")]
        public static extern int SetWindowLong(IntPtr hWnd, int nIndex, IntPtr newWndProc);

        [DllImport("user32.dll")]
        public static extern IntPtr CallWindowProc(IntPtr lpPrevWndFunc, IntPtr hWnd, uint Msg, IntPtr wParam, IntPtr lParam);

        [DllImport("user32.dll")]
        public static extern bool GetClientRect(IntPtr hWnd, out RECT lpRect);

        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        public static extern IntPtr SetWindowsHookEx(int idHook, LowLevelKeyboardProc lpfn, IntPtr hMod, uint dwThreadId);

        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool UnhookWindowsHookEx(IntPtr hhk);

        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        public static extern int CallNextHookEx(IntPtr hhk, int nCode, int wParam, ref KBDLLHOOKSTRUCT lParam);

        // kernel dll

		[DllImport("kernel32.dll", SetLastError = true)]
        public static extern bool QueryPerformanceCounter(out long x);
        
		[DllImport("kernel32.dll", SetLastError = true)]
        public static extern bool QueryPerformanceFrequency(out long x);

		[DllImport("kernel32.dll")]
        public static extern bool Process32First(ToolHelpHandle hSnapshot, ref PROCESSENTRY32 lppe);

        [DllImport("kernel32.dll")]
        public static extern bool Process32Next(ToolHelpHandle hSnapshot, ref PROCESSENTRY32 lppe);

		[DllImport("kernel32.dll", SetLastError = true)]
        public static extern uint FormatMessage(uint dwFlags, IntPtr lpSource, uint dwMessageId, uint dwLanguageId, ref IntPtr lpBuffer, uint nSize, IntPtr pArguments);

        [DllImport("kernel32.dll", SetLastError = true)]
		public static extern IntPtr LocalFree(IntPtr hMem);

        [DllImport("kernel32.dll")]
        public static extern bool EnumUILanguages(EnumUILanguagesProc pUILanguageEnumProc, uint dwFlags, IntPtr lParam);

		[DllImport("kernel32", SetLastError = true, CharSet = CharSet.Unicode)]
		public static extern bool GetDiskFreeSpaceEx(string lpszPath, ref long lpFreeBytesAvailable, ref long lpTotalNumberOfBytes, ref long lpTotalNumberOfFreeBytes);

		[DllImport("kernel32.dll", ExactSpelling = true, CharSet = CharSet.Auto)]
        public static extern int GetCurrentThreadId();

        [DllImport("kernel32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        public static extern IntPtr CreateNamedPipe(String pipeName, uint openMode, uint pipeMode, uint maxInstances, uint outputBufferSize, uint inputBufferSize, uint timeoutInterval, IntPtr pipeSecurityDescriptor);

        [DllImport("kernel32.dll", SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool ConnectNamedPipe(IntPtr namedPipeHandle, ref NativeOverlapped overlapped);

        [DllImport("kernel32.dll", SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool DisconnectNamedPipe(IntPtr hHandle);

        [DllImport("kernel32.dll", SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool ReadFile(IntPtr fileHandle, [Out] byte[] dataBuffer, uint nNumberOfBytesToRead, out uint lpNumberOfBytesRead, [In] ref NativeOverlapped overlapped);

        [DllImport("kernel32.dll", SetLastError = true)]
        public static extern bool WriteFile(IntPtr fileHandle, [Out] byte[] dataBuffer, uint nNumberOfBytesToWrite, out uint lpNumberOfBytesWritten, [In] ref NativeOverlapped overlapped);

        [DllImport("kernel32.dll", SetLastError = true)]
        public static extern bool PeekNamedPipe(IntPtr handle, [Out] byte[] buffer, uint nBufferSize, out uint bytesRead, out uint bytesAvail, out uint BytesLeftThisMessage);

        [DllImport("kernel32.dll")]
        public static extern bool CallNamedPipe(string lpNamedPipeName, byte[] lpInBuffer, uint nInBufferSize, ref byte[] lpOutBuffer, uint nOutBufferSize, out uint lpBytesRead, uint nTimeOut);

        [DllImport("kernel32.dll", SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool CloseHandle(IntPtr hObject);

        [DllImport("kernel32.dll")]
        public static extern void SetLastError(uint dwErrCode);

        [DllImport("kernel32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        public static extern IntPtr GetModuleHandle(string lpModuleName);

        [DllImport("kernel32.dll", SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool FlushFileBuffers(SafeFileHandle hFile);

		[DllImport("kernel32.dll", SetLastError = true)]
		public static extern ToolHelpHandle CreateToolhelp32Snapshot(SnapshotFlags dwFlags, uint th32ProcessID);


        // gdi dll

		[DllImport("gdi32.dll", SetLastError = true)]
        public static extern bool BitBlt(IntPtr hObject, int nXDest, int nYDest, int nWidth, int nHeight, IntPtr hObjSource, int nXSrc, int nYSrc, int dwRop);

		[DllImport("gdi32.dll", ExactSpelling = true, SetLastError = true)]
        public static extern IntPtr CreateCompatibleDC(IntPtr hdc);

        [DllImport("gdi32.dll", ExactSpelling = true, SetLastError = true)]
        public static extern bool DeleteDC(IntPtr hdc);

        [DllImport("gdi32.dll", ExactSpelling = true, SetLastError = true)]
        public static extern IntPtr SelectObject(IntPtr hdc, IntPtr hgdiobj);

        [DllImport("gdi32.dll", ExactSpelling = true, SetLastError = true)]
        public static extern bool DeleteObject(IntPtr hObject);

		[DllImport("gdi32.dll", EntryPoint = "CreateRoundRectRgn")]
        public static extern IntPtr CreateRoundRectRgn(int nLeftRect, int nTopRect, int nRightRect, int nBottomRect, int nWidthEllipse, int nHeightEllipse);

        [DllImport("gdi32.dll")]
        public static extern int SelectClipRgn(IntPtr hdc, IntPtr hrgn);

        // uxtheme dll

        [DllImport("uxtheme", ExactSpelling = true)]
        public static extern int IsAppThemed();

		// wininet dll

        [DllImport("wininet.dll", SetLastError = true)]
        public static extern long DeleteUrlCacheEntry(string url);

		// advapi dll

        [DllImport("advapi32.dll", SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool OpenProcessToken(IntPtr ProcessHandle, TOKEN_ACCESS DesiredAccess, out IntPtr TokenHandle);

		// psapi dll

		[DllImport("psapi.dll")]
		public static extern uint GetModuleFileNameEx(IntPtr hProcess, IntPtr hModule, out StringBuilder lpBaseName, [MarshalAs(UnmanagedType.U4)] ref int nSize);

        // commdlg dll

        [DllImport("Comdlg32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        public static extern bool GetSaveFileName(ref OPENFILENAME lpofn);

        [DllImport("Comdlg32.dll")]
        public static extern int CommDlgExtendedError();

	}

	public class NativeCallWin: INativeCall
    {
		public bool BringWindowToTop(IntPtr window)
        {
			return WinExtern.BringWindowToTop(window);
        }

        public bool CloseWindow(IntPtr window)
        {
			return WinExtern.CloseWindow(window);
        }

        public IntPtr CreateIconIndirect(ref ICONINFO iconinfo)
        {
			return WinExtern.CreateIconIndirect(ref iconinfo);
        }

        public bool DestroyIcon(IntPtr hIcon)
        {
			return WinExtern.DestroyIcon(hIcon);
        }

        public IntPtr SendMessage(IntPtr hWnd, uint Msg, uint wParam, string lParam)
        {
			return WinExtern.SendMessage(hWnd, Msg, wParam, lParam);
        }

        public bool GetComboBoxInfo(IntPtr hwnd, ref COMBOBOXINFO pcbi)
        {
			return WinExtern.GetComboBoxInfo(hwnd, ref pcbi);
        }

        public bool SetForegroundWindow(IntPtr window)
        {
			return WinExtern.SetForegroundWindow(window);
        }

        public bool OpenIcon(IntPtr window)
        {
			return WinExtern.OpenIcon(window);
        }

        public IntPtr FindWindowEx(IntPtr parent, IntPtr childAfter, string className, string windowName)
        {
			return WinExtern.FindWindowEx(parent, childAfter, className, windowName);
        }

        public IntPtr FindWindowWin32(string className, string windowName)
        {
			return WinExtern.FindWindowWin32(className, windowName);
        }

        public int SendMessage(IntPtr window, int message, int wparam, int lparam)
        {
			return WinExtern.SendMessage(window, message, wparam, lparam);
        }

        public int PostMessage(IntPtr window, int message, int wparam, int lparam)
        {
			return WinExtern.PostMessage(window, message, wparam, lparam);
        }

        public IntPtr GetParent(IntPtr window)
        {
			return WinExtern.GetParent(window);
        }

        public IntPtr GetDesktopWindow()
        {
			return WinExtern.GetDesktopWindow();
        }

        public IntPtr GetForegroundWindow()
        {
			return WinExtern.GetForegroundWindow();
        }

        public IntPtr GetLastActivePopup(IntPtr window)
        {
			return WinExtern.GetLastActivePopup(window);
        }

        public int GetWindowText(IntPtr window, ref StringBuilder text, int copyCount)
        {
			return WinExtern.GetWindowText(window, text, copyCount);
        }

        public bool SetWindowText(IntPtr window, string text)
        {
			return WinExtern.SetWindowText(window, text);
        }

        public int GetWindowTextLength(IntPtr window)
        {
			return WinExtern.GetWindowTextLength(window);
        }

        public int SetWindowLong(IntPtr window, int index, int value)
        {
			return WinExtern.SetWindowLong(window, index, value);
        }

        public IntPtr GetWindowLong(IntPtr window, int index)
        {
			return WinExtern.GetWindowLong(window, index);
        }

        public int GetClassName(IntPtr window, ref StringBuilder text, int copyCount)
        {
			return WinExtern.GetClassName(window, text, copyCount);
        }

        public bool EnumChildWindows(IntPtr window, EnumWindowsProc callback, int i)
        {
			return WinExtern.EnumChildWindows(window, callback, i);
        }

        public bool EnumThreadWindows(int threadId, EnumWindowsProc callback, int i)
        {
			return WinExtern.EnumThreadWindows(threadId, callback, i);
        }

        public bool EnumWindows(EnumWindowsProc callback, int i)
        {
			return WinExtern.EnumWindows(callback, i);
        }

        public int GetWindowThreadProcessId(IntPtr window, ref int processId)
        {
			return WinExtern.GetWindowThreadProcessId(window, ref processId);
        }

        public int GetWindowThreadProcessId(IntPtr window, IntPtr ptr)
        {
			return WinExtern.GetWindowThreadProcessId(window, ptr);
        }

        public bool IsChild(IntPtr parent, IntPtr window)
        {
			return WinExtern.IsChild(parent, window);
        }

        public bool IsIconic(IntPtr window)
        {
			return WinExtern.IsIconic(window);
        }

        public bool IsZoomed(IntPtr window)
        {
			return WinExtern.IsZoomed(window);
        }

        public IntPtr GetWindowDC(IntPtr hwnd)
        {
			return WinExtern.GetWindowDC(hwnd);
        }

        public int ReleaseDC(IntPtr hwnd, IntPtr dc)
        {
			return WinExtern.ReleaseDC(hwnd, dc);
        }

        public bool MoveWindow(IntPtr hwnd, int X, int Y, int width, int height, bool repaint)
        {
			return WinExtern.MoveWindow(hwnd, X, Y, width, height, repaint);
        }

        public IntPtr GetNextWindow(IntPtr hwnd, int wFlag)
        {
			return WinExtern.GetNextWindow(hwnd, wFlag);
        }

        public IntPtr GetWindow(IntPtr hWnd, uint uCmd)
        {
			return WinExtern.GetWindow(hWnd, uCmd);
        }

        public bool PeekMessage(out NativeMessage message, IntPtr handle, uint filterMin, uint filterMax, uint removeMsg)
        {
			return WinExtern.PeekMessage(out message, handle, filterMin, filterMax, removeMsg);
        }

        public IntPtr SendMessage(IntPtr hWnd, int msg, IntPtr wParam, ref POINT pt)
        {
			return WinExtern.SendMessage(hWnd, msg, wParam, ref pt);
        }

        public IntPtr SendMessage(IntPtr hWnd, int msg, IntPtr wParam, IntPtr lParam)
        {
			return WinExtern.SendMessage(hWnd, msg, wParam, lParam);
        }

        public IntPtr GetDCEx(IntPtr hWnd, IntPtr hrgnClip, int flags)
        {
			return WinExtern.GetDCEx(hWnd, hrgnClip, flags);
        }

        public int GetGuiResources(IntPtr hProcess, int uiFlags)
        {
			return WinExtern.GetGuiResources(hProcess, uiFlags);
        }

        public int ToUnicode(uint wVirtKey, uint wScanCode, IntPtr lpKeyState, out StringBuilder pwszBuff, int cchBuff, uint wFlags)
        {
			pwszBuff = new StringBuilder();
			int result = WinExtern.ToUnicode(wVirtKey, wScanCode, lpKeyState, pwszBuff, cchBuff, wFlags);
			return result;
        }

        public bool GetKeyboardState(IntPtr lpKeyState)
        {
			return WinExtern.GetKeyboardState(lpKeyState);
        }

        public Int32 FlashWindowEx(ref FLASHWINFO pwfi)
        {
			return WinExtern.FlashWindowEx(ref pwfi);
        }

        public IntPtr GetClipboardViewer()
        {
			return WinExtern.GetClipboardViewer();
        }

        public IntPtr SetClipboardViewer(IntPtr hWnd)
        {
			return WinExtern.SetClipboardViewer(hWnd);
        }

        public bool ChangeClipboardChain(IntPtr hWnd, IntPtr hWndNext)
        {
			return WinExtern.ChangeClipboardChain(hWnd, hWndNext);
        }

        public IntPtr GetDlgItem(IntPtr hDlg, int nIDDlgItem)
        {
			return WinExtern.GetDlgItem(hDlg, nIDDlgItem);
        }

        public IntPtr CreateWindowEx(uint dwExStyle, string lpClassName, string lpWindowName, uint dwStyle, int x, int y, int nWidth, int nHeight, IntPtr hWndParent, IntPtr hMenu, IntPtr hInstance, IntPtr lpParam)
        {
			return WinExtern.CreateWindowEx(dwExStyle, lpClassName, lpWindowName, dwStyle, x, y, nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam);
        }

        public bool SetWindowPos(IntPtr hWnd, IntPtr hWndInsertAfter, int X, int Y, int cx, int cy, uint uFlags)
        {
			return WinExtern.SetWindowPos(hWnd, hWndInsertAfter, X, Y, cx, cy, uFlags);
        }

        public bool ScreenToClient(IntPtr hWnd, ref POINT lpPoint)
        {
			return WinExtern.ScreenToClient(hWnd, ref lpPoint);
        }

        public bool GetWindowRect(IntPtr hWnd, ref RECT lpRect)
        {
			return WinExtern.GetWindowRect(hWnd, ref lpRect);
        }

        public bool SetWindowText(int hWnd, string lpString)
        {
			return WinExtern.SetWindowText(hWnd, lpString);
        }

        public bool DestroyWindow(IntPtr hwnd)
        {
			return WinExtern.DestroyWindow(hwnd);
        }

        public IntPtr SendMessage(IntPtr hWnd, int Msg, IntPtr wParam, string lParam)
        {
			return WinExtern.SendMessage(hWnd, Msg, wParam, lParam);
        }

        public IntPtr SetFocus(IntPtr hwnd)
        {
			return WinExtern.SetFocus(hwnd);
        }

        public bool GetScrollInfo(IntPtr hWnd, int n, ref ScrollInfo lpScrollInfo)
        {
			return WinExtern.GetScrollInfo(hWnd, n, ref lpScrollInfo);
        }

        public int SetScrollInfo(IntPtr hwnd, int fnBar, ref ScrollInfo lpsi, bool fRedraw)
        {
			return WinExtern.SetScrollInfo(hwnd, fnBar, ref lpsi, fRedraw);
        }

        public IntPtr FindWindow(string lpClassName, string lpWindowName)
        {
			return WinExtern.FindWindow(lpClassName, lpWindowName);
        }

        public bool PostMessage(IntPtr hWnd, uint Msg, IntPtr wParam, IntPtr lParam)
        {
			return WinExtern.PostMessage(hWnd, Msg, wParam, lParam);
        }

        public int SetWindowLong(IntPtr hWnd, int nIndex, IntPtr newWndProc)
        {
			return WinExtern.SetWindowLong(hWnd, nIndex, newWndProc);
        }

        public IntPtr CallWindowProc(IntPtr lpPrevWndFunc, IntPtr hWnd, uint Msg, IntPtr wParam, IntPtr lParam)
        {
			return WinExtern.CallWindowProc(lpPrevWndFunc, hWnd, Msg, wParam, lParam);
        }

        public bool GetClientRect(IntPtr hWnd, out RECT lpRect)
        {
			return WinExtern.GetClientRect(hWnd, out lpRect);
        }

        public IntPtr SetWindowsHookEx(int idHook, LowLevelKeyboardProc lpfn, IntPtr hMod, uint dwThreadId)
        {
			return WinExtern.SetWindowsHookEx(idHook, lpfn, hMod, dwThreadId);
        }

        public bool UnhookWindowsHookEx(IntPtr hhk)
        {
			return WinExtern.UnhookWindowsHookEx(hhk);
        }

        public int CallNextHookEx(IntPtr hhk, int nCode, int wParam, ref KBDLLHOOKSTRUCT lParam)
        {
			return WinExtern.CallNextHookEx(hhk, nCode, wParam, ref lParam);
        }

        public bool QueryPerformanceCounter(out long x)
        {
			return WinExtern.QueryPerformanceCounter(out x);
        }

        public bool QueryPerformanceFrequency(out long x)
        {
			return WinExtern.QueryPerformanceFrequency(out x);
        }

        public bool Process32First(ToolHelpHandle hSnapshot, ref PROCESSENTRY32 lppe)
        {
			return WinExtern.Process32First(hSnapshot, ref lppe);
        }

        public bool Process32Next(ToolHelpHandle hSnapshot, ref PROCESSENTRY32 lppe)
        {
			return WinExtern.Process32Next(hSnapshot, ref lppe);
        }

        public uint FormatMessage(uint dwFlags, IntPtr lpSource, uint dwMessageId, uint dwLanguageId, ref IntPtr lpBuffer, uint nSize, IntPtr pArguments)
        {
			return WinExtern.FormatMessage(dwFlags, lpSource, dwMessageId, dwLanguageId, ref lpBuffer, nSize, pArguments);
        }

        public IntPtr LocalFree(IntPtr hMem)
        {
			return WinExtern.LocalFree(hMem);
        }

        public bool EnumUILanguages(EnumUILanguagesProc pUILanguageEnumProc, uint dwFlags, IntPtr lParam)
        {
			return WinExtern.EnumUILanguages(pUILanguageEnumProc, dwFlags, lParam);
        }

        public bool GetDiskFreeSpaceEx(string lpszPath, ref long lpFreeBytesAvailable, ref long lpTotalNumberOfBytes, ref long lpTotalNumberOfFreeBytes)
        {
			return WinExtern.GetDiskFreeSpaceEx(lpszPath, ref lpFreeBytesAvailable, ref lpTotalNumberOfBytes, ref lpTotalNumberOfFreeBytes);
        }

        public int GetCurrentThreadId()
        {
			return WinExtern.GetCurrentThreadId();
        }

        public IntPtr CreateNamedPipe(String pipeName, uint openMode, uint pipeMode, uint maxInstances, uint outputBufferSize, uint inputBufferSize, uint timeoutInterval, IntPtr pipeSecurityDescriptor)
        {
			return WinExtern.CreateNamedPipe(pipeName, openMode, pipeMode, maxInstances, outputBufferSize, inputBufferSize, timeoutInterval, pipeSecurityDescriptor);
        }

        public bool ConnectNamedPipe(IntPtr namedPipeHandle, ref NativeOverlapped overlapped)
        {
			return WinExtern.ConnectNamedPipe(namedPipeHandle, ref overlapped);
        }

        public bool DisconnectNamedPipe(IntPtr hHandle)
        {
			return WinExtern.DisconnectNamedPipe(hHandle);
        }

        public bool ReadFile(IntPtr fileHandle, ref byte[] dataBuffer, uint nNumberOfBytesToRead, out uint lpNumberOfBytesRead, ref NativeOverlapped overlapped)
        {
			return WinExtern.ReadFile(fileHandle, dataBuffer, nNumberOfBytesToRead, out lpNumberOfBytesRead, ref overlapped);
        }

		public bool WriteFile(IntPtr fileHandle, ref byte[] dataBuffer, uint nNumberOfBytesToWrite, out uint lpNumberOfBytesWritten, ref NativeOverlapped overlapped)
        {
			return WinExtern.WriteFile(fileHandle, dataBuffer, nNumberOfBytesToWrite, out lpNumberOfBytesWritten, ref overlapped);
        }

		public bool PeekNamedPipe(IntPtr handle, ref byte[] buffer, uint nBufferSize, out uint bytesRead, out uint bytesAvail, out uint BytesLeftThisMessage)
        {
			return WinExtern.PeekNamedPipe(handle, buffer, nBufferSize, out bytesRead, out bytesAvail, out BytesLeftThisMessage);
        }

        public bool CallNamedPipe(string lpNamedPipeName, byte[] lpInBuffer, uint nInBufferSize, ref byte[] lpOutBuffer, uint nOutBufferSize, out uint lpBytesRead, uint nTimeOut)
        {
			return WinExtern.CallNamedPipe(lpNamedPipeName, lpInBuffer, nInBufferSize, ref lpOutBuffer, nOutBufferSize, out lpBytesRead, nTimeOut);
        }

        public bool CloseHandle(IntPtr hObject)
        {
			return WinExtern.CloseHandle(hObject);
        }

        public void SetLastError(uint dwErrCode)
        {
			WinExtern.SetLastError(dwErrCode);
        }

        public IntPtr GetModuleHandle(string lpModuleName)
        {
			return WinExtern.GetModuleHandle(lpModuleName);
        }

        public bool FlushFileBuffers(SafeFileHandle hFile)
        {
			return WinExtern.FlushFileBuffers(hFile);
        }

		public ToolHelpHandle CreateToolhelp32Snapshot(SnapshotFlags dwFlags, uint th32ProcessID)
        {
			return WinExtern.CreateToolhelp32Snapshot(dwFlags, th32ProcessID);
        }

        public IntPtr CreateCompatibleDC(IntPtr hdc)
        {
			return WinExtern.CreateCompatibleDC(hdc);
        }

        public bool DeleteDC(IntPtr hdc)
        {
			return WinExtern.DeleteDC(hdc);
        }

        public IntPtr SelectObject(IntPtr hdc, IntPtr hgdiobj)
        {
			return WinExtern.SelectObject(hdc, hgdiobj);
        }

        public bool DeleteObject(IntPtr hObject)
        {
			return WinExtern.DeleteObject(hObject);
        }

        public bool BitBlt(IntPtr hObject, int nXDest, int nYDest, int nWidth, int nHeight, IntPtr hObjSource, int nXSrc, int nYSrc, int dwRop)
        {
			return WinExtern.BitBlt(hObject, nXDest, nYDest, nWidth, nHeight, hObjSource, nXSrc, nYSrc, dwRop);
        }

        public IntPtr CreateRoundRectRgn(int nLeftRect, int nTopRect, int nRightRect, int nBottomRect, int nWidthEllipse, int nHeightEllipse)
        {
			return WinExtern.CreateRoundRectRgn(nLeftRect, nTopRect, nRightRect, nBottomRect, nWidthEllipse, nHeightEllipse);
        }

        public int SelectClipRgn(IntPtr hdc, IntPtr hrgn)
        {
			return WinExtern.SelectClipRgn(hdc, hrgn);
        }

        public int IsAppThemed()
        {
			return WinExtern.IsAppThemed();
        }

        public long DeleteUrlCacheEntry(string url)
        {
			return WinExtern.DeleteUrlCacheEntry(url);
        }

        public bool OpenProcessToken(IntPtr ProcessHandle, TOKEN_ACCESS DesiredAccess, out IntPtr TokenHandle)
        {
			return WinExtern.OpenProcessToken(ProcessHandle, DesiredAccess, out TokenHandle);
        }

		public uint GetModuleFileNameEx(IntPtr hProcess, IntPtr hModule, out StringBuilder lpBaseName, ref int nSize)
		{
			return WinExtern.GetModuleFileNameEx(hProcess, hModule, out lpBaseName, ref nSize);
		}

        public bool GetSaveFileName(ref OPENFILENAME lpofn)
        {
			return WinExtern.GetSaveFileName(ref lpofn);
        }

        public int CommDlgExtendedError()
        {
			return WinExtern.CommDlgExtendedError();
        }
    }
}
